package edu.uci.ics.pattis.ics23.collections;


import edu.uci.ics.pattis.introlib.Prompt;
import edu.uci.ics.pattis.introlib.TypedBufferReader;

import java.util.Comparator;
import java.util.Iterator;
import java.io.IOException;



public class DriverForCollection {

  private static Comparator<String> standardComparator =
    new Comparator<String>() {
    public int compare (String a, String b) {
      return a.compareTo(b);
    } 
  };

  private static Class<?>           classToTest;; 
  private static Collection<String> c;


  //Present main menu and get user's choice
  //Iterator menu much smaller, so it is not a method 
  private static char menuPrompt (String preface) {
    System.out.println("\n\n"+preface+"Mutators        Accessors            General");
    System.out.println(preface+"  a - add         c - contains          l - load from file");
    System.out.println(preface+"  A - addAll      C - containsAll       i - iterator test");
    System.out.println(preface+"  r - remove      e - isEmpty           q - quit");  
    System.out.println(preface+"  R - removeAll   s - size");  
    System.out.println(preface+"  K - retainAll   [ - toArray ");
    System.out.println(preface+"  x - clear       n - newEmpty()");
    System.out.println(preface+"                  S - shallowCopy");
    System.out.println(preface+"                  t - toString");
    System.out.println(preface+"                  = - equals ");
    System.out.println(preface+"                  h - hashCode ");

    return Prompt.forChar("\n"+preface+"Enter Command","aArRKxcCes[nSt=hliq");
  }



  ////////////////
  //Driver Program
  ////////////////

  private static void processIteratorCommands(Iterator<?> i, String preface) {
    for (;;)
      try {
        char iCommand = Prompt.forChar("  Enter h[asNext], n[ext], r[emove], [a]ll next, [e]scape, q[uit]","hnraeq");
        if (iCommand == 'h')
          System.out.println("    hasNext = " + i.hasNext());
        else if (iCommand == 'n')
          System.out.println("    next = " + i.next());
        else if (iCommand == 'r')
          i.remove();
        else if (iCommand == 'e')
          processCommands(preface+"  ");
        else if (iCommand == 'a') {
          while (i.hasNext())
            System.out.println("    (all)next = " + i.next());
          System.out.println("    hasNext is now false");
        }
        else if (iCommand == 'q')
          break;
      } catch (Exception e) {e.printStackTrace();}
  }


  private static void processCommands(String preface) {
    for (;;) try {

      char selection = menuPrompt(preface);

      if (selection == 'a') {
        String e = Prompt.forString(preface+"  Enter element to add");
        System.out.print(preface+"  add = " + c.add(e));
      }

      else if (selection == 'A') {
        Collection<String> c2 = getCollection(classToTest,standardComparator);
        for (;;) {
          String e = Prompt.forString(preface+"  Enter element for c2 (QUIT to quit)");
          if (e.equals("QUIT"))
            break;
          c2.add(e);
        }
        c.addAll(c2);
      }

      else if (selection == 'r') {
        String e = Prompt.forString(preface+"  Enter element to remove");
        System.out.print(preface+"  remove = " + c.remove(e));
      }

      else if (selection == 'R') {
        Collection<String> c2 = getCollection(classToTest,standardComparator);
        for (;;) {
          String e = Prompt.forString(preface+"  Enter element for c2 (QUIT to quit)");
          if (e.equals("QUIT"))
            break;
          c2.add(e);
        }
        c.removeAll(c2);
      }

      else if (selection == 'K') {
        Collection<String> c2 = getCollection(classToTest,standardComparator);
        for (;;) {
          String e = Prompt.forString(preface+"  Enter element for c2 (QUIT to quit)");
          if (e.equals("QUIT"))
            break;
          c2.add(e);
        }
        c.retainAll(c2);
      }

      else if (selection == 'x')
        c.clear();

      else if (selection == 'c') {
        String e = Prompt.forString(preface+"  Enter element to check");
        System.out.println(preface+"  contains = " + c.contains(e));
      }

      else if (selection == 'C') {
        Collection<String> c2 = getCollection(classToTest,standardComparator);
        for (;;) {
          String e = Prompt.forString(preface+"  Enter element for c2 (QUIT to quit)");
          if (e.equals("QUIT"))
            break;
          c2.add(e);
        }
        System.out.println(preface+"  containsAll = " + c.containsAll(c2));
      }

      else if (selection == 'e')
        System.out.println(preface+"  isEmpty = " + c.isEmpty());

      else if (selection == 's')
        System.out.println(preface+"  size = " + c.size());

      else if (selection == '[') {
        Object [] a = c.toArray();
        System.out.println(preface+"  toArray() = ");
        for (int i=0; i<a.length; i++)
          System.out.println(preface+"    " + a[i]);
      }   

      else if (selection == 'n') {
        System.out.println("  newEmpty = " + c.newEmpty());
      }   

      else if (selection == 'S') {
        Collection<String> c2 = c.shallowCopy();
        System.out.println(preface+"  c equals shallowCopy? = " + c.equals(c2));
        System.out.println(preface+"  shallowCopy equals c? = " + c2.equals(c));
        System.out.println(preface+"  c == shallowCopy?     = " + (c==c2));
      }   

      else if (selection == 't')
        System.out.println(preface+"  toString = " + c);

      else if (selection == '=') {
        Collection<String> c2 = getCollection(classToTest,standardComparator);
        for (;;) {
          String e = Prompt.forString(preface+"  Enter key for m2 (QUIT to quit)");
          if (e.equals("QUIT"))
            break;
          c2.add(e);
        }
        System.out.println(preface+"  c.equals(m2) = " + c.equals(c2));
        System.out.println(preface+"  m2.equals(m) = " + c2.equals(c));
      }

      else if (selection == 'h')
        System.out.println(preface+"  hashCode = " + c.hashCode());

      else if (selection == 'l') {
        TypedBufferReader input = new TypedBufferReader ("  Enter file (containing strings) name");
        try {
          for (;;)
            c.add(input.readString());
        }catch (IOException ioe){}
      }

      else if (selection == 'i')
        processIteratorCommands(c.iterator(), preface+"  ");

      else if (selection == 'q')
        break;

      else
        System.out.println(preface+"\""+selection+"\" is unknown command");
    } catch (Exception e) {
      e.printStackTrace();
    }

  }



  @SuppressWarnings("unchecked")
  private static Set<String> getCollection(Class<?> cl, Comparator<String> comparator) throws Exception {
    //KLLUDGE: should really use reflection to test for comparator
    if (cl.getName().indexOf("SkipList") != -1)
      return (Set<String>)(cl.getConstructor(new Class[]{Class.forName("java.util.Comparator")})).
      newInstance(new Object[]{comparator});
    else
      return (Set<String>)(cl.getConstructor((Class<?>[])null).newInstance((Object[])null));

  }  




  public static void main(String[] args) throws Exception {
    //Construct object to test
    String kind        = "Collection";
    String packageName = Prompt.forString("Enter package name for classes","edu.uci.ics.pattis.ics23.collections");

    String[] availableClasses =  DriverMagic.getClasses(packageName,kind);
    classToTest = DriverMagic.getClass(packageName,kind,availableClasses); 
    c = getCollection(classToTest,standardComparator);


    //Test object using any method
    processCommands("");
  }


}
