package edu.uci.ics.pattis.ics23.collections;

import edu.uci.ics.pattis.introlib.Prompt;
import edu.uci.ics.pattis.introlib.TypedBufferReader;

import java.util.Comparator;
import java.util.Iterator;
import java.io.IOException;



public class DriverForMap { 

  private static Class <?>          classToTest; 
  private static Map<String,String> m;

  //Present main menu and get user's choice
  //Iterator menu much smaller, so it is not a method 
  private static char menuPrompt (String preface) {
    System.out.println("\n\n"+preface+"Mutators      Accessors            General");
    System.out.println(preface+"  p - put       g - get               l - load from file");
    System.out.println(preface+"  A - putAll    k - containsKay       E - iterator: entries");
    System.out.println(preface+"  r - remove    v - containsValue     K - iterator: keys");  
    System.out.println(preface+"  x - clear     e - isEmpty           V - iterator: values");  
    System.out.println(preface+"                s - size              q - quit");
    System.out.println(preface+"                [ - toArray");
    System.out.println(preface+"                n - newEmpty");
    System.out.println(preface+"                S - shallowCopy");
    System.out.println(preface+"                t - toString");
    System.out.println(preface+"                = - equals ");
    System.out.println(preface+"                h - hashCode ");

    return Prompt.forChar("\n"+preface+"Enter Command","pArxgkves[nSt=hlEKVq");
  }



  ////////////////
  //Driver Program
  ////////////////

  private static void processIteratorCommands(Iterator<?> i, String preface) {
    for (;;)
      try {
        char iCommand = Prompt.forChar("  Enter h[asNext], n[ext], r[emove], [a]ll next, [e]scape, q[uit]","hnraeq");
        if (iCommand == 'h')
          System.out.println("    hasNext = " + i.hasNext());
        else if (iCommand == 'n')
          System.out.println("    next = " + i.next());
        else if (iCommand == 'r')
          i.remove();
        else if (iCommand == 'e')
          processCommands(preface+"  ");
        else if (iCommand == 'a') {
          while (i.hasNext())
            System.out.println("    (all)next = " + i.next());
          System.out.println("    hasNext is now false");
        }
        else if (iCommand == 'q')
          break;
      } catch (Exception e) {e.printStackTrace();}
  }


  private static void processCommands(String preface) {
    for (;;) try {

      char selection = menuPrompt(preface);

      if (selection == 'p') {
        String key   = Prompt.forString(preface+"  Enter key  ");
        String value = Prompt.forString(preface+"  Enter value");
        System.out.println(preface+"  old value = " + m.put(key,value));
      }

      else if (selection == 'A') {
        Map<String,String> m2 = getCollection(classToTest,
            new Comparator<String>() {
          public int compare (String a, String b) {
            return a.compareTo(b);
          } 
        }
        ); 

        for (;;) {
          String k = Prompt.forString(preface+"  Enter key for m2 (QUIT to quit)");
          if (k.equals("QUIT"))
            break;
          String v = Prompt.forString(preface+"  Enter value for m2             ");
          m2.put(k,v);
        }
        m.putAll(m2.entries());
      }

      else if (selection == 'r') {
        String key = Prompt.forString(preface+"  Enter key to remove");
        System.out.println(preface+"  value for removed key = " + m.remove(key));
      }

      else if (selection == 'x')
        m.clear();

      else if (selection == 'g') {
        String key = Prompt.forString(preface+"  Enter key");
        System.out.println(preface+"  get = " + m.get(key));
      }

      else if (selection == 'k') {
        String key = Prompt.forString(preface+"  Enter key to search for");
        System.out.println(preface+"  containsKey = " + m.containsKey(key));
      }

      else if (selection == 'v') {
        String value = Prompt.forString(preface+"  Enter value to search for");
        System.out.println(preface+"  containsValue = " + m.containsValue(value));
      }

      else if (selection == 'e')
        System.out.println(preface+"  isEmpty = " + m.isEmpty());

      else if (selection == 's')
        System.out.println(preface+"  size = " + m.size());

      else if (selection == '[') {
        Object [] a = m.toArray();
        System.out.println(preface+"  toArray = ");
        for (int i=0; i<a.length; i++)
          System.out.println(preface+"    " + a[i]);
      }   

      else if (selection == 'n') {
        System.out.println("  newEmpty = " + m.newEmpty());
      }   

      else if (selection == 'S') {
        Map<String,String> m2 = m.shallowCopy();
        System.out.println(preface+"  m equals shallowCopy? = " + m.equals(m2));
        System.out.println(preface+"  shallowCopy equals m? = " + m2.equals(m));
        System.out.println(preface+"  m == shallowCopy?     = " + (m==m2));
      }   

      else if (selection == 't')
        System.out.println(preface+"  toString = " + m);

      else if (selection == '=') {
        Map<String,String> m2 = getCollection(classToTest,
            new Comparator<String>() {
          public int compare (String a, String b) {
            return a.compareTo(b);
          } 
        }
        ); 

        for (;;) {
          String k = Prompt.forString(preface+"  Enter key for m2 (QUIT to quit)");
          if (k.equals("QUIT"))
            break;
          String v = Prompt.forString(preface+"  Enter value for m2             ");
          m2.put(k,v);
        }
        System.out.println(preface+"  m.equals(m2) = " + m.equals(m2));
        System.out.println(preface+"  m2.equals(m) = " + m2.equals(m));
      }

      else if (selection == 'h')
        System.out.println(preface+"  hashCode = " + m.hashCode());

      else if (selection == 'l') {
        TypedBufferReader input = new TypedBufferReader ("  Enter file (containing strings) name");
        try {
          for (;;)
            m.put(input.readString(), input.readString());
        }catch (IOException ioe){}
      }

      else if (selection == 'E')
        processIteratorCommands(m.entries().iterator(), preface+"  ");

      else if (selection == 'K')
        processIteratorCommands(m.keys().iterator(), preface+"  ");

      else if (selection == 'V')
        processIteratorCommands(m.values().iterator(), preface+"  ");

      else if (selection == 'q')
        break;

      else
        System.out.println(preface+"\""+selection+"\" is unknown command");
    } catch (Exception e) {
      e.printStackTrace();
    }

  }



  @SuppressWarnings("unchecked")
  private static Map<String,String> getCollection(Class<?> cl, Comparator<String> comparator) throws Exception {
    //KLLUDGE: should really use reflection to test for comparator
    if (cl.getName().indexOf("BST") != -1)
      return (Map<String,String>)(cl.getConstructor(new Class[]{Class.forName("java.util.Comparator")})).
      newInstance(new Object[]{comparator});
    else
      return (Map<String,String>)(cl.getConstructor((Class<?>[])null).newInstance((Object[])null));

  }  
  //   {return (Map<String,String>)(cl.getConstructor(null)).newInstance(null);}



  public static void main(String[] args) throws Exception {
    //Construct object to test
    String kind        ="Map";
    String packageName = Prompt.forString("Enter package name for classes","edu.uci.ics.pattis.ics23.collections");

    String[] availableClasses =  DriverMagic.getClasses(packageName,kind);
    classToTest = DriverMagic.getClass(packageName,kind,availableClasses); 
    m = getCollection(classToTest,
        new Comparator<String>() {
      public int compare (String a, String b) {
        return a.compareTo(b);
      } 
    }
    ); 

    //Test object using any method
    processCommands("");
  }


}
